package DD;

use strict;
use warnings;

use base 'Devel::Declare::MethodInstaller::Simple';

sub import {
    my $class = shift;
    my $caller = caller;

    $class->install_methodhandler(
        into    => $caller,
        name    => "method",
    );

    $class->install_methodhandler(
        into    => $caller,
        name    => "func",
    );
}

sub parse_proto {
    my $self = shift;
    my($proto) = @_;

    my @args = split /\s*,\s*/, $proto;

    my $out = q[my $self = shift; ];
    for my $idx (0..$#args) {
        my $arg = $args[$idx];
        $out .= qq[DD::required_arg('$arg') unless (\@_ > $idx); ];
        $out .= qq[my $arg = \$_[$idx]; ];
    }

    return $out;
}

sub required_arg {
    die "missing argument $_[0]";
}

1;
